//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "FondEcran.h"
#include "Lineo.h"

// ATTENTION : les types suivant ne peuvent pas tre combins...
// - FD_ECR_LINEO_LARGE
// - FD_ECR_LINEO_LARGE_A50
// - FD_ECR_VIERGE
FondEcran::FondEcran(Lineo *app_lineo, Uint32 type)
{
	_AppLineo = app_lineo;
    _Type = type;
    SDL_Rect rec_src,rec_des;
    string image_name;
    _Piece1 = NULL;
    _Piece2 = NULL;
    //on affiche le fond de l'cran
    // on affiche l'image suivant le type de fond
    rec_src.x=rec_des.x=0;
    rec_src.y=rec_des.y=0;
    rec_src.w=rec_des.w=800;
    rec_src.h=rec_des.h=600;
    if(_Type & FD_ECR_LINEO_LARGE){
        if(_Type & FD_ECR_PIECE_P3D){
            image_name = (string)(DATA_PATH)+"fond_ecran_lineo_a100_piece_3D.jpg";
        }else{
            image_name = (string)(DATA_PATH)+"fond_ecran_lineo_a100.jpg";
        }
    }else if(_Type & FD_ECR_LINEO_LARGE_A50){
        if(_Type & FD_ECR_PIECE_P3D){
            image_name = (string)(DATA_PATH)+"fond_ecran_lineo_a50_piece_3D.jpg";
        }else{
            image_name = (string)(DATA_PATH)+"fond_ecran_lineo_a50.jpg";
        }
    }else if(_Type & FD_ECR_VIERGE){
        if(_Type & FD_ECR_PIECE_P3D){
            image_name = (string)(DATA_PATH)+"fond_ecran_vierge_piece_3D.jpg";
        }else{
            image_name = (string)(DATA_PATH)+"fond_ecran_vierge.jpg";
        }
    }else{
        // histoire d'tre sr d'avoir un fond en cas de mauvais masque pour le type...
        image_name = (string)(DATA_PATH)+"fond_ecran_vierge.jpg";
    }
    _AppLineo->_Screen->addSprite(FD_ECR_SPRITE_NAME,image_name,Z_FOND_ECRAN);
    _AppLineo->_Screen->addSpriteImage(FD_ECR_SPRITE_NAME,rec_src,rec_des);
    // affichage du logo en miniature en haut  gauche si demand
    if(_Type & FD_ECR_LINEO_SMALL){
        rec_src.x=0;
        rec_src.y=0;
        rec_des.x=10;
        rec_des.y=10;
        rec_src.w=rec_des.w=205;
        rec_src.h=rec_des.h=89;
        _AppLineo->_Screen->addSprite(FD_ECR_LOGO_SPRITE_NAME,(string)(DATA_PATH)+"logo_lineo_small.png",Z_FOND_ECRAN+1);
        _AppLineo->_Screen->addSpriteImage(FD_ECR_LOGO_SPRITE_NAME,rec_src,rec_des);
    }
    // affichage du logo de natsimhan en bas  gauche par defaut
    if(!(_Type & FD_ECR_NO_LOGO_NATSIMHAN)){
        rec_src.x=0;
        rec_des.x=10;
        rec_src.y=0;
        rec_des.y=SCREEN_H-74;
        rec_src.w=rec_des.w=62;
        rec_src.h=rec_des.h=64;
        _AppLineo->_Screen->addSprite(FD_ECR_SPRITE_LOGO_N,(string)(DATA_PATH)+"logo_N.png",Z_LOGO_N);
        _AppLineo->_Screen->addSpriteImage(FD_ECR_SPRITE_LOGO_N,rec_src,rec_des);
    }
    // affichage des deux pices vertes en bas  droite par defaut
    if(!(_Type & FD_ECR_NO_PIECES_3D)){
        _Piece1 = new Piece(_AppLineo,P_FORME_CARRE|P_FORME_PETITE|P_FORME_COLOR_1|P_FORME_PLEINE);
        _Piece1->drawScreen(SCREEN_W - 100, SCREEN_H - 20,Z_LOGO_N);
        _Piece2 = new Piece(_AppLineo,P_FORME_ROND|P_FORME_GRANDE|P_FORME_COLOR_2|P_FORME_CREUSE);
        _Piece2->drawScreen(SCREEN_W - 40, SCREEN_H - 20,Z_LOGO_N);
    }

}

FondEcran::~FondEcran()
{
    // on efface le fond de l'cran
    _AppLineo->_Screen->delSprite(FD_ECR_SPRITE_NAME);
    // on efface le logo de lino
    _AppLineo->_Screen->delSprite(FD_ECR_LOGO_SPRITE_NAME);
    // on efface le logo de natsimhan
    _AppLineo->_Screen->delSprite(FD_ECR_SPRITE_LOGO_N);
    // on efface les pices
    delete(_Piece1);
    delete(_Piece2);
}
