//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "GeneriqueDebut.h"
#include "Lineo.h"

GeneriqueDebut::GeneriqueDebut(Lineo *app_lineo)
{
	_AppLineo = app_lineo;
    SDL_Rect rec_src,rec_des;

	_Compteur=0;
    // on initialise le fond d'cran
    _FondEcran = new FondEcran(_AppLineo, FD_ECR_VIERGE|FD_ECR_NO_PIECES_3D);
    // on affiche le nom natsimhan en plein milieu de l'cran
    rec_src.x=0;
    rec_des.x=0;
    rec_src.y=0;
    rec_des.y=0;
    rec_src.w=rec_des.w=800;
    rec_src.h=rec_des.h=600;
	_AppLineo->_Screen->addSprite(GENERIQUE_DEBUT_SPRITE_NATSIMHAN,(string)(DATA_PATH)+"nom_natsimhan.png",Z_MENU_TEXTE);
    _AppLineo->_Screen->addSpriteImage(GENERIQUE_DEBUT_SPRITE_NATSIMHAN,rec_src,rec_des);
	// on affiche le texte de copyright
#ifdef Nokia770
    string copyright_str = "Lino "+(string)VERSION+"\nCopyright (c) 2005-2006 Natsimhan\nNokia770 port by Uwe Koch\nhttp:\/\/www.linuxvision.de\n"+_AppLineo->_Langue->get("licence et copyright");
#else
    string copyright_str = "Lino "+(string)VERSION+"\nCopyright (c) 2005-2006 Natsimhan\n"+_AppLineo->_Langue->get("licence et copyright");
#endif
    _CopyrightStrId = _AppLineo->_VTexte->add(FONT_12_WHITE,copyright_str,TEXTE_X_LEFT|TEXTE_Y_BOTTOM,80,10,Z_MENU_TEXTE);
}

GeneriqueDebut::~GeneriqueDebut()
{
    // on efface les sprites
    _AppLineo->_Screen->delSprite(GENERIQUE_DEBUT_SPRITE_NATSIMHAN);
    // on efface le texte
    _AppLineo->_VTexte->del(_CopyrightStrId);
	// on supprime tous les pointeurs
	delete(_FondEcran);
}

void GeneriqueDebut::processEvents(SDL_Event *event)
{

    if (event->user.code == EVENT_TIMER){
        _Compteur++;
        // on test si a fait 6 sec.
        if(_Compteur==6*TIMER_NB_TICK_FOR_1_S){
            _AppLineo->_Events->addEvent(EVENT_CREATE_VUE_MAIN_MENU);
        }
    }

    switch (event->type) {
        case SDL_MOUSEBUTTONUP:
        case SDL_KEYDOWN:
            // On quitte le gnrique de debut
            _AppLineo->_Events->addEvent(EVENT_CREATE_VUE_MAIN_MENU);
        break;
    }
}
