//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA



#ifndef __JOUEUR_IA_H__
#define __JOUEUR_IA_H__

#include <vector>
#include <string>
#include <ctime>
#include <cstdlib>
#include <SDL.h>

#include "Piece.h"
#include "NoeudIA.h"
#include "LaDonne.h"
#include "Events.h"
#include "Templates.h"
#include "Config.h"

#define IA_JOUEUR_MIN 0
#define IA_JOUEUR_MAX 1

#define IA_SDL_DELAY 5

class Lineo;

using namespace std;

typedef vector<NoeudIA> vnoeud;

// No description
class JoueurIA
{
  //*******************
  //* variables membres
	private:
        Lineo *_AppLineo;

        string _Niveau;
        
        Uint8 _PieceChoisie;
        Uint8 _IChoisi;
        Uint8 _JChoisi;

  //*******************
  //* fonctions membres
	public:
		JoueurIA(Lineo* app_lineo);
		~JoueurIA();
		
		void pieceFirstWait(LaDonne donne);
		void pieceWait(LaDonne donne);
        void cercleWait(LaDonne donne);

    private:
		void meilleurCoup(LaDonne donne);
        void strategie(NoeudIA noeud);
        vnoeud listeSousNoeuds(NoeudIA noeud);
        void noeudHasard(NoeudIA noeud);
        vnoeud listeFacile(vnoeud liste_IA);
        vnoeud listeMoyen(vnoeud liste_IA);
        vnoeud listeDifficile(vnoeud liste_IA);
        vnoeud listeImpossible(vnoeud liste_IA);
        void dernierCoup(NoeudIA noeud);
//        void testLigne(Uint8 piece_1, Uint8 piece_2, Uint8 piece_3, Uint8 piece_4, bool *duo, bool *trio);
};

#endif // __JOUEUR_IA_H__
