//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __VUE_CHOIX_COULEUR_PIECE_H__
#define __VUE_CHOIX_COULEUR_PIECE_H__

#include <SDL.h>

#include "Defines.h"
#include "Screen.h"
#include "Menu.h"
#include "Config.h"
#include "FondEcran.h"
#include "Langue.h"

class Lineo;

using namespace std;

typedef vector<string> vstring;
typedef vector<string>::iterator vstring_iter;

// permet  l'utilisateur de choisir la couleur des pices du jeu
class VueChoixCouleurPiece
{
  //*******************
  //* variables membres
	private:
        Lineo *_AppLineo;

        Menu* 			_Menu;
        FondEcran* 		_FondEcran;

		vstring 		_ListeCouleurs;
		vstring_iter 	_ListeCoulIter1;
		vstring_iter 	_ListeCoulIter2;

		Uint8 			_NoItemColor1;
		Uint8 			_NoItemColor2;

  //*******************
  //* fonctions membres
	public:
		VueChoixCouleurPiece(Lineo* app_lineo);
		~VueChoixCouleurPiece();
		void processEvents(SDL_Event *event);
		
	private:
		vstring_iter listeCoulNext(vstring_iter current_iter); // permet d'aller  l'itrateur suivant, ou retourner au premier si le dernier est atteind
		vstring_iter listeCoulPrev(vstring_iter current_iter); // permet d'aller  l'itrateur prcdent, ou retourner au dernier si le premier est atteind

		vstring_iter findCouleur(string couleur);// rcupre l'itrateur d'une couleur dans la liste
};

#endif // __VUE_CHOIX_COULEUR_PIECE_H__
