//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#include "VueChoixModeVideo.h"
#include "Lineo.h"

VueChoixModeVideo::VueChoixModeVideo(Lineo* app_lineo)
{
	_AppLineo = app_lineo;
    // on initialise le fond d'cran
    _FondEcran = new FondEcran(_AppLineo, FD_ECR_VIERGE|FD_ECR_LINEO_SMALL);
    // on initialise le menu
    _Menu = new Menu(_AppLineo, _AppLineo->_Langue->get("Mode video"), true, EVENT_CREATE_VUE_OPTION);
    _NoItemFullScreen = _Menu->addItem(_AppLineo->_Langue->get("Plein ecran"),EVENT_MODE_VIDEO_FULL_SCREEN,MENU_TYPE_RADIO);
    _NoItemFenetre    = _Menu->addItem(_AppLineo->_Langue->get("Fenetre"),EVENT_MODE_VIDEO_FENETRE,MENU_TYPE_RADIO);
    _Menu->draw();
    // puis on positionne le radio bouton
    // en renseignant le mode vido de la config
    string mode_video = _AppLineo->_Config->get("mode_video");
    if(mode_video == "fenetre"){
        _Menu->setItemOn(_NoItemFenetre);
    }else{ // moyen par defaut
        _Menu->setItemOn(_NoItemFullScreen);
    }

}

VueChoixModeVideo::~VueChoixModeVideo()
{
    // on libre les pointeurs des classes
	delete(_FondEcran);
    delete(_Menu);
}

// gre les vnements de la vue
void VueChoixModeVideo::processEvents(SDL_Event *event)
{
    // on s'occupe de notre vue en premier
    switch (event->type) {
        case SDL_USEREVENT:
            switch (event->user.code)
            {
                case EVENT_MODE_VIDEO_FULL_SCREEN:
                    _Menu->setItemOn(_NoItemFullScreen);
                    _AppLineo->_Config->set("mode_video","plein_ecran");
                    // on initialise la classe Screen en plein cran
                    if(!_AppLineo->_Screen->setVideoMode(true)){
                        // le plein cran n'a pas march alors on remet en fentr
                        _AppLineo->_Events->addEvent(EVENT_MODE_VIDEO_FENETRE);
                    }
                break;
                case EVENT_MODE_VIDEO_FENETRE:
                    _Menu->setItemOn(_NoItemFenetre);
                    _AppLineo->_Config->set("mode_video","fenetre");
                    // on initialise la classe Screen en fentr
                    _AppLineo->_Screen->setVideoMode(false);
                break;
            }
        break;
   	}
   	// puis du menu
    _Menu->processEvents(event);
}
