//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2005 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "VueOption.h"
#include "Lineo.h"

VueOption::VueOption(Lineo *app_lineo, Uint16 provenance)
{
	_AppLineo = app_lineo;
    // on initialise le fond d'cran
    _FondEcran = new FondEcran(app_lineo, FD_ECR_VIERGE|FD_ECR_LINEO_SMALL);
    // on initialise le _Menu
    _Menu = new Menu(app_lineo, _AppLineo->_Langue->get("Options"), true, provenance);
#ifndef Nokia770
    _Menu->addItem(_AppLineo->_Langue->get("Nom des joueurs"),EVENT_OPTION_JOUEUR,MENU_TYPE_LIEN,EVENT_CREATE_VUE_OPTION);
#endif
    _Menu->addItem(_AppLineo->_Langue->get("Vue de dessus"),EVENT_OPTION_VUE_DESSUS);
    _Menu->addItem(_AppLineo->_Langue->get("Couleurs des pieces"),EVENT_CREATE_VUE_CHOIX_COULEUR_PIECE,MENU_TYPE_LIEN,EVENT_CREATE_VUE_OPTION);
    _Menu->addItem(_AppLineo->_Langue->get("Musique"),EVENT_OPTION_MUSIQUE);
#ifndef Nokia770
    _Menu->addItem(_AppLineo->_Langue->get("Mode video"),EVENT_CREATE_VUE_CHOIX_MODE_VIDEO);
#endif
    _Menu->addItem(_AppLineo->_Langue->get("Langue"),EVENT_CREATE_VUE_CHOIX_LANGUE);
    _Menu->draw();

}

VueOption::~VueOption()
{
    // on libre les pointeurs des classes
	delete(_FondEcran);
    delete(_Menu);
}

// gre les vnements de la vue
void VueOption::processEvents(SDL_Event *event)
{
    _Menu->processEvents(event);
}
